searchNodes=[{"doc":"Documentation for Sorcery .","ref":"Sorcery.html","title":"Sorcery","type":"module"},{"doc":"","ref":"Sorcery.html#unmount/0","title":"Sorcery.unmount/0","type":"function"},{"doc":"","ref":"Sorcery.LiveHelper.html","title":"Sorcery.LiveHelper","type":"module"},{"doc":"","ref":"Sorcery.Msg.html","title":"Sorcery.Msg","type":"module"},{"doc":"","ref":"Sorcery.Msg.html#error/2","title":"Sorcery.Msg.error/2","type":"function"},{"doc":"","ref":"Sorcery.Msg.html#noop/0","title":"Sorcery.Msg.noop/0","type":"function"},{"doc":"","ref":"Sorcery.Msg.html#success/1","title":"Sorcery.Msg.success/1","type":"function"},{"doc":"","ref":"Sorcery.Portal.html","title":"Sorcery.Portal","type":"module"},{"doc":"","ref":"Sorcery.Portal.html#all_portals/1","title":"Sorcery.Portal.all_portals/1","type":"function"},{"doc":"","ref":"Sorcery.Portal.html#format_indices/1","title":"Sorcery.Portal.format_indices/1","type":"function"},{"doc":"","ref":"Sorcery.Portal.html#new/1","title":"Sorcery.Portal.new/1","type":"function"},{"doc":"","ref":"Sorcery.Portal.html#tk_ref/1","title":"Sorcery.Portal.tk_ref/1","type":"function"},{"doc":"","ref":"Sorcery.PortalMonitor.html","title":"Sorcery.PortalMonitor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Sorcery.PortalMonitor.html#child_spec/1","title":"Sorcery.PortalMonitor.child_spec/1","type":"function"},{"doc":"","ref":"Sorcery.PortalMonitor.html#monitor/2","title":"Sorcery.PortalMonitor.monitor/2","type":"function"},{"doc":"","ref":"Sorcery.PortalMonitor.html#start_link/1","title":"Sorcery.PortalMonitor.start_link/1","type":"function"},{"doc":"Introduction In Sorcery, we keep data sync'd across nodes. So it naturally follows that we should keep the metadata sync'd across codes. Schema module In a typical phoenix app, you might have a Player schema for a game. You can replace part, or all of that module with Sorcery. Observe: defmodule MyApp.Player do require Sorcery.SpecDb @spec_table %{ user_id : %{ t : :id , require_update : false } , name : %{ t : :string , default : &quot;Player&quot; , min : 3 , max : 45 } , age : %{ t : :integer , min : 0 , max : 200 , bump : true } } Sorcery.SpecDb . build_schema_module ( &quot;player&quot; ) # Alternately: # # def spec_table, do: @spec_table # Sorcery.SpecDb.build_ecto_schema(name) # Sorcery.SpecDb.build_norm_schema() # Sorcery.SpecDb.build_streamdata_generator() # Sorcery.SpecDb.build_changesets() end Exploring the results What does this achieve? Well, I think the test module actually speaks for itself. Read the comments carefully defmodule MyApp.PlayerTest do use ExUnit.Case use ExUnitProperties use Norm alias MyApp.Player test &quot;build_schema macro&quot; do # Builds the struct via Ecto.Schema assert Map . get ( % Player { } , :name ) == &quot;Player&quot; # Builds the Norm schema assert ! valid? ( %{ name : &quot;hello&quot; } , Player . t ( ) ) assert valid? ( % Player { user_id : 1 , age : 23 , name : &quot;hello&quot; } , Player . t ( ) ) assert valid? ( %{ user_id : 1 , age : 23 , name : &quot;hello&quot; } , Player . t ( ) ) end property &quot;Generates Players&quot; do # First, we generate a player with random data that matches the spec_table # The map you pass into gen/1 will override any random values. check all player &lt;- Player . gen ( %{ user_id : 24 } ) do assert valid? ( player , Player . t ( ) ) # We get a valid changeset cs = Player . sorcery_update ( % Player { id : player . id } , player ) assert cs . valid? # If we use numbers outside the min/max, using `bump: true` will set it the same min/max value. # Remember our spec_table included: # age: %{t: :integer, min: 0, max: 200, bump: true} player = Map . put ( player , :age , 9999999 ) cs = Player . sorcery_update ( % Player { id : player . id } , player ) assert cs . changes . age == 200 assert cs . valid? # Instead of causing an invalid changeset, it just &#39;bumped&#39; it to the :max value. end end end The table_spec To see more about the options to pass into each field, see the types section.","ref":"Sorcery.SpecDb.html","title":"Sorcery.SpecDb","type":"module"},{"doc":"Adds sorcery_insert/2 and sorcery_update/2 , based on the @spec_table","ref":"Sorcery.SpecDb.html#build_changesets/0","title":"Sorcery.SpecDb.build_changesets/0","type":"macro"},{"doc":"# Injects this use Ecto.Schema schema &quot;name&quot; do field :fieldname , :type end # While passing in all the data from @spec_table","ref":"Sorcery.SpecDb.html#build_ecto_schema/1","title":"Sorcery.SpecDb.build_ecto_schema/1","type":"macro"},{"doc":"Adds the MODULE .t() function, for usage with Norm.","ref":"Sorcery.SpecDb.html#build_norm_schema/0","title":"Sorcery.SpecDb.build_norm_schema/0","type":"macro"},{"doc":"# Macro which automatically adds to your module: def spec_table , do : @spec_table Sorcery.SpecDb . build_ecto_schema ( name ) Sorcery.SpecDb . build_norm_schema ( ) Sorcery.SpecDb . build_streamdata_generator ( ) Sorcery.SpecDb . build_changesets ( )","ref":"Sorcery.SpecDb.html#build_schema_module/1","title":"Sorcery.SpecDb.build_schema_module/1","type":"macro"},{"doc":"Adds the MODULE .gen() function, for generating data in property based testing with StreamData","ref":"Sorcery.SpecDb.html#build_streamdata_generator/0","title":"Sorcery.SpecDb.build_streamdata_generator/0","type":"macro"},{"doc":"Whether the value should be coerced to its min/max if beyond that range.","ref":"Sorcery.SpecDb.html#t:bump/0","title":"Sorcery.SpecDb.bump/0","type":"type"},{"doc":"Whether this field should be cast inside sorcery_insert/2","ref":"Sorcery.SpecDb.html#t:cast_insert/0","title":"Sorcery.SpecDb.cast_insert/0","type":"type"},{"doc":"Whether this field should be cast inside sorcery_update/2","ref":"Sorcery.SpecDb.html#t:cast_update/0","title":"Sorcery.SpecDb.cast_update/0","type":"type"},{"doc":"If t: :list, then every item must be of this type","ref":"Sorcery.SpecDb.html#t:coll_of/0","title":"Sorcery.SpecDb.coll_of/0","type":"type"},{"doc":"The default value if nothing else set.","ref":"Sorcery.SpecDb.html#t:default/0","title":"Sorcery.SpecDb.default/0","type":"type"},{"doc":"Sets the length of a list type.","ref":"Sorcery.SpecDb.html#t:length/0","title":"Sorcery.SpecDb.length/0","type":"type"},{"doc":"The highest possible number, or string length","ref":"Sorcery.SpecDb.html#t:max/0","title":"Sorcery.SpecDb.max/0","type":"type"},{"doc":"The lowest possible number, or string length","ref":"Sorcery.SpecDb.html#t:min/0","title":"Sorcery.SpecDb.min/0","type":"type"},{"doc":"A list of possible options","ref":"Sorcery.SpecDb.html#t:one_of/0","title":"Sorcery.SpecDb.one_of/0","type":"type"},{"doc":"Whether this field should be in validate_required inside sorcery_insert/2","ref":"Sorcery.SpecDb.html#t:require_insert/0","title":"Sorcery.SpecDb.require_insert/0","type":"type"},{"doc":"Whether this field should be in validate_required inside sorcery_update/2","ref":"Sorcery.SpecDb.html#t:require_update/0","title":"Sorcery.SpecDb.require_update/0","type":"type"},{"doc":"Default: true. Whether Norm should treat this as a required field. Does nothing if :default field is set.","ref":"Sorcery.SpecDb.html#t:required/0","title":"Sorcery.SpecDb.required/0","type":"type"},{"doc":"Required. The type of this field","ref":"Sorcery.SpecDb.html#t:t/0","title":"Sorcery.SpecDb.t/0","type":"type"},{"doc":"[] - Create test/domain/Sorcery.SpecDb.NormHelpers.exs [] - Write public fn heads (fill them out later) [] - Complete all docs [] - Complete all checkboxes, commit, and push..","ref":"Sorcery.SpecDb.NormHelpers.html","title":"Sorcery.SpecDb.NormHelpers","type":"module"},{"doc":"","ref":"Sorcery.SpecDb.NormHelpers.html#build_schema/1","title":"Sorcery.SpecDb.NormHelpers.build_schema/1","type":"function"},{"doc":"","ref":"Sorcery.SpecDb.NormHelpers.html#required_keys/1","title":"Sorcery.SpecDb.NormHelpers.required_keys/1","type":"function"},{"doc":"","ref":"Sorcery.Specs.Portals.html","title":"Sorcery.Specs.Portals","type":"module"},{"doc":"","ref":"Sorcery.Specs.Portals.html#assigned_portal/0","title":"Sorcery.Specs.Portals.assigned_portal/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Portals.html#fun_atom/0","title":"Sorcery.Specs.Portals.fun_atom/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Portals.html#guard/0","title":"Sorcery.Specs.Portals.guard/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Portals.html#portal/0","title":"Sorcery.Specs.Portals.portal/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Portals.html#portal_presence/0","title":"Sorcery.Specs.Portals.portal_presence/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Portals.html#portal_ref/0","title":"Sorcery.Specs.Portals.portal_ref/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html","title":"Sorcery.Specs.Primative","type":"module"},{"doc":"","ref":"Sorcery.Specs.Primative.html#any/0","title":"Sorcery.Specs.Primative.any/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#atom/0","title":"Sorcery.Specs.Primative.atom/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#attr/0","title":"Sorcery.Specs.Primative.attr/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#bool/0","title":"Sorcery.Specs.Primative.bool/0","type":"function"},{"doc":"Format for the collection of all entities %{ user: %{ 1 =&gt; %{ id : 1 , name : &quot;asdf&quot; } , 2 =&gt; %{ id : 2 , name : &quot;qwerty&quot; } , }, comment: %{ 1 =&gt; %{ id : 1 , body : &quot;asdf&quot; } , 2 =&gt; %{ id : 2 , body : &quot;qwerty&quot; } , }, }","ref":"Sorcery.Specs.Primative.html#db/0","title":"Sorcery.Specs.Primative.db/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#entity/0","title":"Sorcery.Specs.Primative.entity/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#id/0","title":"Sorcery.Specs.Primative.id/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#id_int/0","title":"Sorcery.Specs.Primative.id_int/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#list/0","title":"Sorcery.Specs.Primative.list/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#map/0","title":"Sorcery.Specs.Primative.map/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#msg/0","title":"Sorcery.Specs.Primative.msg/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#pid/0","title":"Sorcery.Specs.Primative.pid/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#presences/0","title":"Sorcery.Specs.Primative.presences/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#src/0","title":"Sorcery.Specs.Primative.src/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#string/0","title":"Sorcery.Specs.Primative.string/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#struct/0","title":"Sorcery.Specs.Primative.struct/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#subject/0","title":"Sorcery.Specs.Primative.subject/0","type":"function"},{"doc":"Map format for a list of entities of a given type. %{ 1 =&gt; %{id: 1, name: &quot;asdf&quot;}, 2 =&gt; %{id: 2, name: &quot;qwerty&quot;}, }","ref":"Sorcery.Specs.Primative.html#tablemap/0","title":"Sorcery.Specs.Primative.tablemap/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#tk/0","title":"Sorcery.Specs.Primative.tk/0","type":"function"},{"doc":"","ref":"Sorcery.Specs.Primative.html#watch_meta/0","title":"Sorcery.Specs.Primative.watch_meta/0","type":"function"},{"doc":"This is the quintessential single source of truth in the app. The db format The first thing to understand is the concept of a 'db'. Every DB is in the following format: db = %{ :user =&gt; %{ 1 =&gt; %{ id : 1 , name : &quot;Aaron&quot; } , 3 =&gt; %{ id : 3 , name : &quot;Not Aaron&quot; } , }, :comment =&gt; %{ 78 =&gt; %{ id : 78 , user_id : 1 , body : &quot;Hello&quot; } } } Note the the top level keys are atom names related to an ecto schema. For example src = Src.new(%{ :user =&gt; %{id: 1, name: &quot;...&quot;}, :user =&gt; %{id: 2, name: &quot;...&quot;}, }) Src.get_in(src, [:user, 1]) =&gt; %{id: 1, name: &quot;...&quot;} Src.get_in(src, [:something, 123]) =&gt; %{id: 123, foo: 123421} Src.get_in(src, [:something, 123, :foo]) =&gt; 123421","ref":"Sorcery.Src.html","title":"Sorcery.Src","type":"module"},{"doc":"Returns all original and/or changed ids for a table. Note, this will return an id even after applying Src.delete.","ref":"Sorcery.Src.html#all_ids/2","title":"Sorcery.Src.all_ids/2","type":"function"},{"doc":"","ref":"Sorcery.Src.html#delete/3","title":"Sorcery.Src.delete/3","type":"function"},{"doc":"","ref":"Sorcery.Src.html#get_in/2","title":"Sorcery.Src.get_in/2","type":"function"},{"doc":"","ref":"Sorcery.Src.html#intercept/1","title":"Sorcery.Src.intercept/1","type":"function"},{"doc":"Process a list of interceptor functions, each taking, and returning a Src.","ref":"Sorcery.Src.html#intercept/2","title":"Sorcery.Src.intercept/2","type":"function"},{"doc":"","ref":"Sorcery.Src.html#new/2","title":"Sorcery.Src.new/2","type":"function"},{"doc":"","ref":"Sorcery.Src.html#put_args/3","title":"Sorcery.Src.put_args/3","type":"function"},{"doc":"","ref":"Sorcery.Src.html#put_in/3","title":"Sorcery.Src.put_in/3","type":"function"},{"doc":"Send Src back in time to its state from n interceptors ago.","ref":"Sorcery.Src.html#time_backward/2","title":"Sorcery.Src.time_backward/2","type":"function"},{"doc":"Send Src past n interceptors without being changed by them.","ref":"Sorcery.Src.html#time_forward/2","title":"Sorcery.Src.time_forward/2","type":"function"},{"doc":"","ref":"Sorcery.Src.html#update_args/4","title":"Sorcery.Src.update_args/4","type":"function"},{"doc":"","ref":"Sorcery.Src.html#update_in/3","title":"Sorcery.Src.update_in/3","type":"function"},{"doc":"","ref":"Sorcery.Storage.GenserverAdapter.html","title":"Sorcery.Storage.GenserverAdapter","type":"module"},{"doc":"","ref":"Sorcery.Storage.GenserverAdapter.Query.html","title":"Sorcery.Storage.GenserverAdapter.Query","type":"module"},{"doc":"Given a list of ALL connected portals, return a list of pids, such that at least one of their portals is affected by the qmeta. Careful, we're potentially working with huge amounts of data.","ref":"Sorcery.Storage.GenserverAdapter.Query.html#affected_pids/2","title":"Sorcery.Storage.GenserverAdapter.Query.affected_pids/2","type":"function"},{"doc":"Determine if a portal is observing any of the entities in the qmeta","ref":"Sorcery.Storage.GenserverAdapter.Query.html#affects_portal?/2","title":"Sorcery.Storage.GenserverAdapter.Query.affects_portal?/2","type":"function"},{"doc":"","ref":"Sorcery.Storage.GenserverAdapter.Query.html#affects_portals?/2","title":"Sorcery.Storage.GenserverAdapter.Query.affects_portals?/2","type":"function"},{"doc":"","ref":"Sorcery.Storage.GenserverAdapter.Query.html#entity_matches_clause?/2","title":"Sorcery.Storage.GenserverAdapter.Query.entity_matches_clause?/2","type":"function"},{"doc":"","ref":"Sorcery.Storage.GenserverAdapter.Query.html#portal_watching_entity?/2","title":"Sorcery.Storage.GenserverAdapter.Query.portal_watching_entity?/2","type":"function"},{"doc":"Given a list of portals, recalculate such that: Every tuple of {ref, attr} in a guard will become a MapSet of values in the resolve_guard. Every entity matching the portal will be found, and indexed","ref":"Sorcery.Storage.GenserverAdapter.Query.html#resolve_portal/2","title":"Sorcery.Storage.GenserverAdapter.Query.resolve_portal/2","type":"function"},{"doc":"Given a portal, return a db of entities satisfying it.","ref":"Sorcery.Storage.GenserverAdapter.Query.html#solve_portal/2","title":"Sorcery.Storage.GenserverAdapter.Query.solve_portal/2","type":"function"},{"doc":"Given a list of portals, return a db of entities satisfying it.","ref":"Sorcery.Storage.GenserverAdapter.Query.html#solve_portals/2","title":"Sorcery.Storage.GenserverAdapter.Query.solve_portals/2","type":"function"},{"doc":"Pure functions for all portal manipulation.","ref":"Sorcery.Storage.GenserverAdapter.UpdatePortal.html","title":"Sorcery.Storage.GenserverAdapter.UpdatePortal","type":"module"},{"doc":"Takes a portal, returns a portal with an updates :ids.","ref":"Sorcery.Storage.GenserverAdapter.UpdatePortal.html#add_ids/2","title":"Sorcery.Storage.GenserverAdapter.UpdatePortal.add_ids/2","type":"function"},{"doc":"Takes a portal, returns a portal with the indexed values filled in.","ref":"Sorcery.Storage.GenserverAdapter.UpdatePortal.html#add_indices/2","title":"Sorcery.Storage.GenserverAdapter.UpdatePortal.add_indices/2","type":"function"},{"doc":"","ref":"Sorcery.Utils.Maps.html","title":"Sorcery.Utils.Maps","type":"module"},{"doc":"","ref":"Sorcery.Utils.Maps.html#deep_merge/2","title":"Sorcery.Utils.Maps.deep_merge/2","type":"function"},{"doc":"","ref":"Sorcery.Utils.Maps.html#delete_in/2","title":"Sorcery.Utils.Maps.delete_in/2","type":"function"},{"doc":"Like mkdir -p , but for elixir maps. Safely does put_in, assuming nothing but maps all the way down.","ref":"Sorcery.Utils.Maps.html#put_in_p/3","title":"Sorcery.Utils.Maps.put_in_p/3","type":"function"}]